#ifndef WORKSPACE_H
#define WORKSPACE_H

#include <QWidget>
#include <QThread>

class ImageLoader:public QThread
{
    Q_OBJECT
public:
    ImageLoader();
    void fetchImage(QString path);
private:
    void run();
signals:
    void ready(QImage&);
private:
    QString url;
};

//Need to be scrollable image
class Workspace : public QWidget
{
    Q_OBJECT
public:
    Workspace(QWidget *parent = 0);
    void loadImage(QString fileName);
    virtual void paintEvent(QPaintEvent *);
    void keyPressEvent(QKeyEvent *);
signals:

    //testing

public slots:
    void testEffect();
    void zoomIn();
    void zoomOut();
private slots:
    void onImageLoaded(QImage&);
private:
    QImage mImage;
    ImageLoader *mImageLoader;
};

#endif // WORKSPACE_H
